<template>
  <div class="sellOutOrder pagePadding">
    <div v-if="powers.some((i) => i == '001')">
      <ex-table
        v-loading="loading"
        :table="table"
        :data="tableData"
        :columns="columns"
        :page="pageInfo"
        :size="size"
        @page-curr-change="handlePageChange"
        @page-size-change="handleSizeChange"
        @screen-reset="
          pageInfo.curr = 1;
          parmValue.page = 1;
          searchList();
        "
        @screen-submit="
          pageInfo.curr = 1;
          parmValue.page = 1;
          searchList();
        "
        @selection="selection_change"
      >
        <template #table-header="{}">
          <div style="width: 100%">
            <el-row style="padding: 0 0 0 80px">
              <el-col :span="4" style="width: 375px; display: flex; align-items: center">
                <p style="margin-right: 10px">添加时间:</p>
                <period-date-picker
                  :type="1"
                  :start="parmValue.start"
                  :end="parmValue.end"
                  :width="'134px'"
                  :size="searchSize"
                  @timeReturned="handleTime"
                />
              </el-col>
              <el-col :span="4" style="width: 375px; display: flex; align-items: center">
                <p style="margin-right: 10px">发货时间:</p>
                <period-date-picker
                  :type="1"
                  :start="parmValue.start_sendtime"
                  :end="parmValue.end_sendtime"
                  :width="'134px'"
                  :size="searchSize"
                  @timeReturned="handleTime($event, true)"
                />
              </el-col>

              <el-col :span="4" style="width: 230px; padding: 0px 0 0 10px">
                <search-customer
                  :value="customerCode"
                  :size="searchSize"
                  :placeholder="'客户公司名称'"
                  :names="parmValue.supplierName"
                  :is-detail="true"
                  @searchChange="customerChange"
                />
              </el-col>

              <el-col :span="3" style="width: 66px; float: right">
                <el-button
                  :size="searchSize"
                  type="primary"
                  style="float: right; margin-left: 5px"
                  @click="searchList"
                >
                  刷新
                </el-button>
              </el-col>
              <el-col
                :span="4"
                style="width: 66px; float: right"
                v-if="powers.some((i) => i == '087')"
              >
                <el-button
                  type="primary"
                  style="margin-left: 30px"
                  @click="download"
                  :size="searchSize"
                  class="fr"
                >
                  导出
                </el-button>
              </el-col>
            </el-row>
            <el-row style="padding-top: 10px">
              <el-col :span="4" style="width: 150px">
                <el-select
                  :size="searchSize"
                  v-model="parmValue.status"
                  filterable
                  clearable
                  placeholder="状态"
                  style="width: 100%"
                  @change="
                    pageInfo.curr = 1;
                    parmValue.page = 1;
                    searchList();
                  "
                >
                  <el-option
                    v-for="item in statusOptions"
                    :key="'status' + item.id"
                    :label="item.label"
                    :value="item.id"
                  />
                </el-select>
              </el-col>
              <el-col :span="4" style="width: 150px; padding: 0 0 0 9px">
                <el-select
                  :size="searchSize"
                  v-model="parmValue.order_type"
                  filterable
                  clearable
                  placeholder="商品来源"
                  style="width: 100%"
                  @change="
                    pageInfo.curr = 1;
                    parmValue.page = 1;
                    searchList();
                  "
                >
                  <el-option
                    v-for="item in xs_order_type_options"
                    :key="'orderstatus' + item.id"
                    :label="item.label"
                    :value="item.id"
                  />
                </el-select>
              </el-col>
              <el-col :span="4" style="width: 500px; padding: 0 0 0 10px">
                <el-input
                  clearable
                  :size="searchSize"
                  placeholder="关键字"
                  v-model="s_input"
                  maxlength="40"
                  class="input-with-select"
                >
                  <el-select
                    style="width: 140px"
                    v-model="select"
                    slot="prepend"
                    placeholder="关键字类型"
                  >
                    <el-option label="销售订单编号" value="orderCode" />
                    <el-option label="发货申请单编号" value="outCode" />
                    <el-option label="供应商名称" value="supplier_name" />
                    <el-option label="商品编号" value="good_code" />
                    <el-option label="商品名称" value="good_name" />
                    <el-option label="申请人部门" value="company_name" />
                    <el-option label="申请人" value="apply_name" />
                    <el-option label="采购单编号" value="cgdNo" />
                  </el-select>
                  <el-button
                    slot="append"
                    icon="el-icon-search"
                    @click="
                      pageInfo.curr = 1;
                      parmValue.page = 1;
                      handleValue();
                    "
                  ></el-button>
                </el-input>
              </el-col>
              <el-col :span="4" style="width: 66px" class="fr">
                <el-button
                  type="warning"
                  class="fr"
                  :size="searchSize"
                  @click="restSearch"
                >
                  重置
                </el-button>
              </el-col>

              <el-col
                :span="4"
                style="width: 66px; float: right"
                v-if="powers.some((i) => i == '090')"
              >
                <el-button
                  type="primary"
                  style="margin-left: 30px"
                  @click="routeGoto('sendOutOrder', {})"
                  :size="searchSize"
                  class="fr"
                >
                  批量发货
                </el-button>
              </el-col>
            </el-row>
          </div>
        </template>
        <template #status="{ scope }">
          <el-tag
            :size="tablebtnSize"
            :type="scope.row.status == '0' ? 'warning' : ''"
            v-text="
              (statusOptions.find((item) => item.id == scope.row.status) || {}).label ||
              '--'
            "
          ></el-tag>
        </template>
        <template #order_type="{ scope }">
          <el-tag
            :size="tablebtnSize"
            v-text="
              (
                xs_order_type_options.find((item) => item.id == scope.row.order_type) ||
                {}
              ).label || '--'
            "
          ></el-tag>
        </template>

        <template #operation="{ scope }">
          <el-tooltip
            v-if="powers.some((i) => i == '007')"
            effect="dark"
            content="详情"
            placement="top"
          >
            <i
              class="el-icon-view tb-icon"
              @click="getRouter('sellOutOrderDetail', scope.row.outCode)"
            ></i>
          </el-tooltip>
          <el-tooltip
            v-if="Number(scope.row.status) >= 2"
            effect="dark"
            content="分享"
            placement="top"
          >
            <i class="el-icon-share tb-icon" @click="handleShare(scope.row.outCode)"></i>
          </el-tooltip>
        </template>
      </ex-table>
      <add-edit
        :id="modelId"
        :sitem="sitem"
        :show-model="showModel"
        :is-detail="isDetail"
        @refresh="searchList"
        @cancel="showModel = false"
      />
    </div>
    <div v-else>
      <no-auth></no-auth>
    </div>
  </div>
</template>
<script>
import mixinPage from "@/mixins/elPaginationHandle";
import resToken from "@/mixins/resToken";
import { mapGetters } from "vuex";
import urlConfig from "@/apis/url-config";
import asyncRequest from "@/apis/service/sellOut/sellOutOrder";
import addEdit from "./components/addEdit.vue";
import { columns } from "./columns";
import { shareWebUrl } from "@/config";
import { xs_order_type_options } from "@/assets/js/statusList";
export default {
  name: "sellOutOrder",
  mixins: [mixinPage, resToken],
  components: {
    addEdit,
  },
  computed: {
    ...mapGetters(["tablebtnSize", "searchSize", "size"]),
    powers() {
      const tran =
        this.$store.getters.btnList.find((item) => item.menu_route == "sellOutOrder") ||
        {};
      const { action } = tran ?? {};
      return action ?? [];
    },
  },
  data() {
    return {
      select: "cgdNo",
      s_input: "",
      customerCode: [], //客户公司code
      fileUrl: urlConfig.baseURL,
      changeList: [],

      // post_ownOptions: [
      //   { id: "1", label: "客户承担" },
      //   { id: "2", label: "公司承担" },
      //   { id: "3", label: "供应商承担" },
      // ],
      sitem: null,
      // 状态

      statusOptions: [
        { id: "0", label: "待发货" },
        { id: "1", label: "待库管发货" },
        { id: "2", label: "已发货待收货" },
        { id: "3", label: "已收货" },
        { id: "4", label: "已全部退货" },
      ],
      loading: true,
      showModel: false,
      isDetail: false,
      modelId: 0,
      parmValue: {
        order_type: "",
        orderCode: "",
        apply_name: "", //申请人名称
        cgdNo: "",
        start: "",
        end: "",
        start_sendtime: "",
        end_sendtime: "",
        supplier_name: "",
        companyNo: "",
        good_code: "",
        good_name: "",
        outCode: "",
        status: "",
        company_name: "", //申请人部门
        page: 1, // 页码
        size: 15, // 每页显示条数
      },
      // 表格 - 数据
      tableData: [],
      // 表格 - 参数
      table: {
        stripe: true,
        border: true,
        _defaultHeader_: ["setcol"],
      },
      // 表格 - 分页
      pageInfo: {
        size: 15,
        curr: 1,
        total: 0,
      },
      // 表格 - 列参数
      columns,
      xs_order_type_options,
    };
  },
  mounted() {
    // return;
    const { back } = this.$route.query;
    if (back) {
      this.parmValue = JSON.parse(back);
      console.log(this.parmValue);
      const { page, size } = this.parmValue;
      // this.parmValue.start = start || last_start;
      // this.parmValue.end = end || last_end;
      if (this.parmValue.companyNo.length > 0) {
        this.customerCode = [this.parmValue.companyNo];
      }

      this.pageInfo = {
        size: size,
        curr: page,
        total: 0,
      };
      //多选条件
      this.select = this.parmValue.select;
      // this.sselect = this.parmValue.sselect;
      this.s_input = this.parmValue.s_input;
    } else {
      this.select = "cgdNo";
      //  this.sselect = "创建时间"
    }
    this.searchList();
  },

  methods: {
    handleShare(outCode) {
      const url = shareWebUrl + outCode;

      const input = document.createElement("input");

      document.body.appendChild(input);
      input.value = url;

      input.select();

      document.execCommand("Copy");

      this.$message.success("复制成功");

      document.body.removeChild(input);
    },
    getRouter(toRouter, queryId) {
      if (toRouter && queryId) {
        let model = {
          id: queryId,
          // type: 'view',
        };

        //有多选框的条件
        this.parmValue.select = this.select;
        // this.parmValue.sselect = this.sselect ;
        this.parmValue.s_input = this.s_input;
        //
        let routerModel = {
          options: JSON.parse(JSON.stringify(this.parmValue)),
          router: this.$route.path,
        };
        model.preModel = JSON.stringify(routerModel);

        this.routeGoto(toRouter, model);
      } else {
        this.$message.warning("暂未找到相关流程！");
      }
    },
    //选中触发函数
    selection_change(e) {
      const { list } = e;
      //选中的数组集合
      this.changeList = list.length > 0 ? JSON.parse(JSON.stringify(list)) : [];
    },
    //导出文件 （）
    async download() {
      if (this.changeList.length <= 0) {
        this.$message.warning("请选择有效数据");
        return;
      }

      let model = {
        outCodes: [],
      };
      this.changeList.forEach((item) => {
        model.outCodes.push(item.outCode);
      });

      // const res = await asyncRequest.exportcgdlist(model)

      if (!this.loading) {
        this.loading = true;
        let httpType = `aplication/zip`;
        axios({
          method: "post",
          url: this.fileUrl + "admin/exportsaleout",
          responseType: "blob",
          data: model,
          headers: {
            // 'Content-Type': 'multipart/form-data',
            // Accept: "application/vnd.ms-excel"
            Accept: httpType,
          },
        })
          .then((res) => {
            // console.log(res)
            // console.log(this.fileUrl)
            // return;
            if (res && res.status == 200 && res.data) {
              let url = window.URL.createObjectURL(
                new Blob([res.data], {
                  // type: "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet;charset=utf-8",
                  type: httpType,
                })
              );
              let link = document.createElement("a");
              link.style.display = "none";
              link.href = url;
              let excelName = "发货申请单.zip";
              link.setAttribute("download", excelName);
              document.body.appendChild(link);
              link.click();
              link.remove();
              window.URL.revokeObjectURL(url); //释放掉blob对象
              this.$message.success(`${message}导出成功！`);
              setTimeout(() => {
                this.loading = false;
              }, 500);
            } else {
              this.$message.error(res.data.message);
              setTimeout(() => {
                this.loading = false;
              }, 500);
            }
          })
          .catch((error) => {
            console.log(error);
            this.loading = false;
          });
      }
    },
    restSearch() {
      this.customerCode = [];
      this.select = "cgdNo";
      this.s_input = "";
      this.parmValue = {
        order_type: "",
        orderCode: "",
        apply_name: "", //申请人名称
        cgdNo: "",
        start: "",
        end: "",
        // supplierNo: "",
        companyNo: "",
        good_code: "",
        good_name: "",
        outCode: "",
        status: "",
        company_name: "", //申请人部门
        page: 1, // 页码
        size: 15, // 每页显示条数
      };
      // 表格 - 分页
      this.pageInfo = {
        size: 15,
        curr: 1,
        total: 0,
      };
      this.searchList();
    },

    openModal(id, isDetail, sitem) {
      this.showModel = true;
      this.modelId = id;
      this.isDetail = isDetail;
      this.sitem = sitem;
    },
    async deleteById(id, status) {
      await this.$confirm("确定要删除？", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(async () => {
          const model = {
            id: id,
            status: status === "1" ? "0" : "1",
          };
          const res = await asyncRequest.status(model);
          if (res && res.code === 0) {
            this.$notify.success({
              title: "删除成功",
              message: "",
            });
            this.searchList();
          } else if (res && res.code >= 100 && res.code <= 104) {
            await this.logout();
          } else {
            this.$message.warning(res.message);
          }
        })
        .catch(() => {
          console.log("取消");
        });
    },
    // 列表搜索
    async searchList() {
      if (
        (this.parmValue.start !== "" && this.parmValue.end === "") ||
        (this.parmValue.start === "" && this.parmValue.end !== "")
      ) {
        this.$message.warning("时间区间不完整！");
        return;
      }
      this.loading = true;
      let model = JSON.parse(JSON.stringify(this.parmValue));

      const res = await asyncRequest.list(model);
      if (res && res.code === 0 && res.data) {
        this.tableData = res.data.list;
        this.pageInfo.total = Number(res.data.count);
        this.tableData.forEach((v) => {
          v.good_class = "";
          if (v.can && v.can.length > 0) {
            v.can.forEach((x, i) => {
              v.good_class += i === 0 ? x.name : "/" + x.name;
            });
          }
        });
      } else if (res && res.code >= 100 && res.code <= 104) {
        await this.logout();
      } else {
        this.tableData = [];
        this.pageInfo.total = 0;
      }
      this.loading = false;
    },

    async statusConfirm(id, status) {
      let str = status === "1" ? "禁用" : "启用";
      await this.$confirm("确定要改为" + str + "?", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(async () => {
          this.loading = true;
          const model = {
            id: id,
            status: status === "1" ? "0" : "1",
          };
          const res = await asyncRequest.status(model);
          if (res && res.code === 0) {
            this.loading = false;
            this.$notify.success({
              title: "状态修改成功！",
              message: "",
            });
            await this.searchList();
          } else if (res && res.code >= 100 && res.code <= 104) {
            await this.logout();
          } else {
            this.$message.warning(res.message);
          }
        })
        .catch(() => {
          console.log("取消");
        });
    },
    // 时间选择事件
    async handleTime(e, isSend) {
      const startProp = isSend ? "start_sendtime" : "start";
      const endProp = isSend ? "end_sendtime" : "end";

      if (e.startTime !== "") {
        this.parmValue[startProp] = e.startTime;
      } else {
        this.parmValue[startProp] = "";
      }
      if (e.endTime !== "") {
        this.parmValue[endProp] = e.endTime;
      } else {
        this.parmValue[endProp] = "";
      }
      if (this.parmValue[startProp] !== "" && this.parmValue[endProp] !== "") {
        this.pageInfo.curr = 1;
        this.parmValue.page = 1;
        await this.searchList();
      }
    },
    async customerChange(e) {
      if (e && e.id) {
        this.customerCode = [e.code];
        this.parmValue.supplierName = e.label;
        this.parmValue.companyNo = e.code;
      } else {
        this.customerCode = [];
        this.parmValue.supplierName = "";
        this.parmValue.companyNo = "";
      }
      this.pageInfo.curr = 1;
      this.parmValue.page = 1;
      await this.searchList();
    },
    async handleValue() {
      this.parmValue.orderCode = this.select === "orderCode" ? this.s_input : "";
      this.parmValue.outCode = this.select === "outCode" ? this.s_input : "";
      this.parmValue.supplier_name = this.select === "supplier_name" ? this.s_input : "";

      // this.parmValue.supplierName =
      //   this.select === "supplierNo" ? this.s_input : "";
      this.parmValue.good_code = this.select === "good_code" ? this.s_input : "";
      this.parmValue.good_name = this.select === "good_name" ? this.s_input : "";
      this.parmValue.apply_name = this.select === "apply_name" ? this.s_input : "";
      this.parmValue.cgdNo = this.select === "cgdNo" ? this.s_input : "";
      this.parmValue.company_name = this.select === "company_name" ? this.s_input : "";

      await this.searchList();
    },
  },
};
</script>
<style lang="scss" scoped>
.zxoutOrder {
}
</style>
